<?php
namespace Indeed\Uap\Admin;

class UserProfile
{
    /**
     * @param none
     * @return none
     */
    public function __construct()
    {
        add_action( 'uap_print_admin_page', [ $this, 'page' ], 10, 1 );
    }

    /**
     * @param string
     * @return string
     */
    public function page( $tab='' )
    {
        global $indeed_db;
		global $wp_roles;
        if ( $tab != 'user_profile' ){
            return;
        }
        $affiliateId = empty( $_GET['affiliate_id'] ) ? 0 : esc_sql( $_GET['affiliate_id'] );
        $uid = $indeed_db->get_uid_by_affiliate_id( $affiliateId );
        require_once UAP_PATH . 'classes/MLM_Get_All_Children.class.php';
        $mlm = new \MLM_Get_All_Children( $affiliateId );
        $mlmParent = $indeed_db->mlm_get_parent( $affiliateId );
        if ( empty( $mlmParent ) ){
            $mlmParent = '';
        } else {
            $parentUid = $indeed_db->get_uid_by_affiliate_id( $mlmParent );
            $mlmParent = $indeed_db->get_username_by_wpuid( $parentUid );
        }

        $data = [
                  'uid'                 => $uid,
                  'user_name'           => $indeed_db->get_username_by_wpuid( $uid ),
                  'user_email'          => $indeed_db->get_email_by_uid( $uid ),
                  'full_name'           => $indeed_db->get_wp_full_name( $uid ),
                  'member_since'        => uap_convert_date_to_us_format( $indeed_db->getRegisterDate( $uid ) ),
                  'description'         => get_user_meta( $uid, 'description', true ),
				  'role'				=> $wp_roles->roles[$indeed_db->get_user_first_role( $uid )]['name'],
                  'avatar'              => uap_get_avatar_for_uid( $uid ),
                  'rank'                => $indeed_db->getRankName( $indeed_db->get_affiliate_rank(0, $uid) ),
                  'stats'               => $indeed_db->get_stats_for_reports( '', $affiliateId ),
                  'user_meta'           => $indeed_db->getAllUserMeta( $uid ),
                  'mlm'                 => $this->printMlm( $affiliateId, $indeed_db->get_username_by_wpuid( $uid ) ),
                  'coupons'             => $indeed_db->get_coupons_for_affiliate( $affiliateId ),
                  'last_ten_referrals'  => $indeed_db->get_referrals( $limit=10, 0, false, 'r.date', 'DESC', [ 'r.affiliate_id = ' . $affiliateId]),
                  'cpm'                 => $indeed_db->getCPMForAffiliate( $affiliateId ),
        ];
        $view = new \Indeed\Uap\IndeedView();
        echo $view->setTemplate( UAP_PATH . 'admin/views/user_profile.php' )
                  ->setContentData( $data )
                  ->getOutput();
    }

    /**
     * @param int
     * @param string
     * @return string
     */
    private function printMlm( $affiliateId=0, $affiliateUsername='' )
    {
        global $indeed_db;
        require_once UAP_PATH . 'classes/MLM_Get_All_Children.class.php';
        $children_object = new \MLM_Get_All_Children($affiliateId);
        $data = [
                  'items'         => $children_object->get_results(),
                  'parent'        => $indeed_db->mlm_get_parent($affiliateId),
        ];
        if (empty($data['parent'])){
            $data['parent'] = '';
        } else {
            $parentUid = $indeed_db->get_uid_by_affiliate_id($data['parent']);
            $data['parent'] = $indeed_db->get_username_by_wpuid($parentUid);
        }
        $view = new \Indeed\Uap\IndeedView();
        return $view->setTemplate( UAP_PATH . 'admin/views/mlm-view_affiliate_children.php' )
                  ->setContentData( [ 'data' => $data, 'affiliate_name' => $affiliateUsername ], true )
                  ->getOutput();
    }

}
